#!/usr/bin/perl
# 
# Copyright 2010-2012 Kevin Gimpel
# Licensed under the modified BSD license. See the root directory LICENSE 
# file included with this distribution.
#
# Prints the weights that led to the best BLEU score on the tuning data
# given a directory containing rampion.iter*.err log files.
#
# Usage: ./get-best-model.pl directory_containing_rampion_err_files
#

if (scalar(@ARGV) != 1) {
  print "Usage: get-best-model.pl directory_containing_rampion_err_files\n";
  exit;
}

$dir = $ARGV[0];

@lines = `more $dir/*err | grep BL|grep sys|grep only|sort -g`;

$numl = @lines;
$currmax = -10.0;
$maxline = "";
$maxlinenum = -1;
for ($i = $numl - 1; $i >= 0; $i--) {
  # 21 onlycurr_kbest system avg BLEU+1 = 0.370358 corp BLEU = 35.25, 78.5/46.0/27.5/16.4 (BP=0.987, ratio=0.987, hyp_len=27542, ref_len=27906)
  # print $lines[$i];
  chomp($lines[$i]);
  $lines[$i] =~ m/^(\d+)\tonlycurr.+corp BLEU = (.+), .+ \(BP.+\)$/;
  $linenum = $1;
  $bleu = $2;
  # print $linenum."\t".$bleu."\n";
  if ($bleu > $currmax) {
    $currmax = $bleu;
    $maxline = $lines[$i];
    $maxlinenum = $linenum;
  }
  # print $lines[$i];
}
print "Found max $currmax with model $maxlinenum:\n";
print $maxline."\n";


